package gsample;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Parameter.java
 * <pre>
 *
 * </pre>
 * $Id$
 * @author Takayosi_sato
 *
 */
public class Parameter {

	// `FbNΏە
	private String value = null;
	// `FbNeo^Xg
	private List checkerList = null;
	// G[bZ[W
	private String errorMessage = null;

	/**
	 * Constructor for Parameter.
	 * <pre>
	 *
	 * </pre>
	 * @param value - `FbNΏە
	 */
	public Parameter(String value) {
		this.value = value;
		checkerList = new ArrayList();
	}

	/**
	 * <pre>
	 * checkerIuWFNgǉo^B
	 * </pre>
	 * @param checker
	 */
	public void addChecker(ParamChecker checker){
		checkerList.add(checker);
	}

	/**
	 * <pre>
	 * o^ĂcheckerIuWFNggpāA`FbNsB
	 * </pre>
	 * @return boolean - ͕soꂽꍇfalseB
	 */
	public boolean executeCheck(){
		for (Iterator iter = checkerList.iterator(); iter.hasNext();) {
			ParamChecker checker = (ParamChecker)iter.next();
			errorMessage = checker.check(value);
			if(errorMessage != null){
				return false;
			}
		}
		errorMessage = null;
		return true;
	}

	/**
	 * <pre>
	 * G[bZ[W擾
	 * </pre>
	 * @return String - error message
	 */
	public String getErrorMessage() {
		return errorMessage;
	}

}
