package gsample;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ResourceBundle;

/**
 * ConnectionFactory.java
 * <pre>
 *
 * </pre>
 * $Id$
 * @author Takayosi_sato
 *
 */
public class ConnectionFactory {

	private static final String CONF_PATH = "conf.database";

	/**
	 * <pre>
	 * ڑ擾
	 * </pre>
	 * @return conn
	 * @exception SQLException
	 */
	public static Connection getConnection() throws SQLException {
		Connection conn = null;
		try {
			Class.forName(readProp("db.driver_package"));
			conn =
				DriverManager.getConnection(
					readProp("db.url"),
					readProp("db.user"),
					readProp("db.pass"));

			//Context ctx = new InitialContext();
			//DataSource ds = (DataSource)ctx.lookup("java:OracleDS");
			//conn = ds.getConnection();

		}
		catch (Exception ex) {
			ex.printStackTrace();
			throw new SQLException();
		}
		return conn;
	}

	/**
	 * <pre>
	 *
	 * </pre>
	 * @param conn
	 */
	public static void freeConnection(Connection conn){
		try {
			if(conn != null){
				conn.close();
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
	}


	/**
	 * <pre>
	 * w肳ꂽkey̒l擾B
	 * </pre>
	 * @param key
	 * @return value
	 */
	public static String readProp(String key) {
		String value = "";
		try {
			ResourceBundle resource = ResourceBundle.getBundle(CONF_PATH);
			value = resource.getString(key);
		}
		//warning.
		catch (Exception ex) {
			ex.printStackTrace();
		}
		return value;
	}
}
